Unit MacTP;
{ Enthaelt Routinen, die das Verwenden von Turbo-Pascal unter Mac OSX erleichtern }


{ Written by: Wolfgang Marwan    } 
{ Version vom  : 21. Jan  2019   }

{ Provided as Supplementary Material to : Rätzel et al.     }




interface


uses
   crt;



Procedure PowerBreak (Wo_Wurde_Unterbrochen: string);
{ unterbricht sofort, wenn eine Taste gedrueckt wird      }
{ Sollte in jede Schleife als Notbremse eingebaut werden, }
{ da am neuen Mac ein TP Programm nicht mit Ctrl C        }
{ gestoppt werden kann                                    }


Function StrToInt (S:string): integer;
{ Wandelt String in Integer um und ueberprueft, ob der String eine }
{ Zahl ergibt                                                      }


Function TextDateiVorhanden (Dateiname: string): boolean;
{ Prueft, ob die angegebene Datei vorhanden ist }


Function ReadFigs (var Esc: boolean): string;

{ ReadFigs laesst nur Eingaben zu, die aus Ziffern, Esc oder CR bestehen
  verbesserte Variante von Readln: liefert den String einer Zeile,
  bis CR oder Esc gedrueckt wurde, und liefert ausserdem zurueck,
  ob Esc gedrueckt wurde.                                        }
  
  
function TastenCode : char;
       { Liefert den Tasten-Code der gedrueckten Taste -
       wenn keine Taste gedrueckt ist wird #0 Åbergeben
       Routine von Walter Mayer, Neualbenreuth}  
  
  
function TastenCodeWait : char;
       { Wartet auf Tastendruck und Åbergibt den entsprechenden
       Tastencode Routine von Walter Mayer, Neualbenreuth}

  
 Procedure Hitany;
       { Wartet, bis irgend eine Taste gedrueckt wurde }
       { Hit any key to continue !!                    }
       
       





implementation



Procedure PowerBreak (Wo_Wurde_Unterbrochen: string);
{ unterbricht sofort, wenn eine Taste gedrueckt wird      }
{ Sollte in jede Schleife als Notbremse eingebaut werden, }
{ da am neuen Mac ein TP Programm nicht mit Ctrl C        }
{ gestoppt werden kann                                    }

begin { of Powerbreak }
   if Keypressed then
        begin
           Writeln;
           Writeln ('Fehler ', Wo_Wurde_Unterbrochen);
           ChDir ('c:\Progent');
           Readln;
           Halt (1);
        end; {of if Keypressed...}
end; { of Powerbreak }




Function StrToInt (S:string): integer;
{ Wandelt String in Integer um und ueberprueft, ob der String eine }
{ Zahl ergibt                                                      }

var 
   FEHL : integer;
   Zahl : integer;
   
begin
   Val (S, Zahl, FEHL);
   if FEHl <> 0 then 
         begin
            Writeln ('Fehler bei der Umwandlung String to Integer...');
            Writeln ('at Position: ', S);
            ChDir ('c:\Progent');
            Readln;
            Halt (1);
         end; 
    StrToInt := Zahl;        
end; { of StrToInt }



Function TextDateiVorhanden (Dateiname: string): boolean;
{ Prueft, ob die angegebene Datei vorhanden ist }

var
   Datei : text;

begin { of DateiVorhanden }
   Assign (Datei, Dateiname);
   {$I-} Reset (Datei);  {$I+}
   if (IOResult = 0) then
      begin
         Close (Datei);
         TextDateiVorhanden := TRUE;
      end
   else
      TextDateiVorhanden := FALSE;
end;  { of DateiVorhanden }




Function ReadFigs (var Esc: boolean): string;

{ ReadFigs laesst nur Eingaben zu, die aus Ziffern, Esc oder CR bestehen
  verbesserte Variante von Readln: liefert den String einer Zeile,
  bis CR oder Esc gedrueckt wurde, und liefert ausserdem zurueck,
  ob Esc gedrueckt wurde.                                        }

var
   Buchstabe      : char;
   Zeile          : string;
   SichtbareZeile : string;
   XPos, YPos     : byte;
   i              : integer;

begin { of ReadString};
   Esc := False;
   XPos := WhereX; YPos := WhereY;
   Buchstabe := ' ';
   Zeile :='';
   while not (Esc or (Buchstabe = #13)) do
   begin
      Buchstabe := TastenCodeWait;
      if (Buchstabe <> #27) then
         begin
            if ((Buchstabe > #47) and (Buchstabe < #58)) then
            begin
               Write (Buchstabe);
               if (Buchstabe <> chr (13)) then
                   Zeile := ConCat (Zeile, Buchstabe);
               end;
            if (Buchstabe = #8 {BS} ) then
                begin { entferne das letzte Zeichen aus der Zeile }
                   i := Length (Zeile);
                   Delete (Zeile, i, 1);
               (***ClrEol;  ***)
                   SichtbareZeile := ConCat (Zeile, ' ');
                   GotoXY (XPos, YPos);
                   Write (SichtbareZeile);
                   if ((XPos+i-1) >= XPos) then
                       GotoXY (XPos + i - 1, YPos)
                     else
                       GotoXY (XPos, YPos);
                end; { of = BS: entferne das letzte Zeichen aus der Zeile }
            Esc:= False;
         end else Esc:= True;
   end;
   ReadFigs:= Zeile;
end;



function TastenCode : char;
  { Liefert den Tasten-Code der gedrueckten Taste -
  wenn keine Taste gedrueckt ist wird #0 Åbergeben
  Routine von Walter Mayer}

  var
    Ch : char;

  begin { of TastenCode }
    if keypressed
      then
        begin
          Ch := ReadKey;
          if Ch = #0
            then Ch := ReadKey;
          TastenCode := Ch;
        end
      else
        TastenCode := #0;
  end; { of TastenCode }





function TastenCodeWait : char;
  { Wartet auf Tastendruck und uebergibt den entsprechenden
  Tastencode Routine von Walter Mayer}

  var
    Ch : char;

  begin { of TastenCodeWait }
    repeat
      Ch := TastenCode;
    until Ch <> #0;
    TastenCodeWait := Ch;
  end; { of TastenCodeWait }
  
  
  
  
Procedure Hitany;
{ Wartet, bis irgend eine Taste gedrueckt wurde }
{ Hit any key to continue !!                    }

var
   dummy : char;

begin { of Hitany }
   repeat until Keypressed;
   dummy := readkey;
end; { of Hitany }



END. { of Unit MacTP }









































